cartoon
	ld a,(curLev)
	cp maxlev / 3
	jp z,cart10
	cp maxlev * 2 / 3
	jp z,cart20
	cp maxlev
	ret nz
cart30
	call putScene
	ld de,ani30
	jp cartGo
	
cart20
	call putScene
	ld de,ani20
	jp cartGo
	
cart10
	call putScene
	ld de,ani10
cartGo	push de
	call muzOff
	pop de
	call usOn
	call cartAni
	ld b,150
cart00	halt
	xor a
	in a,(254)
	cpl
	and 31
	jp nz,cart01
	djnz cart00
cart01	call noKey
	jp muzOn

wFrames	push bc
	ld a,c
	and a
	jr z,wfr1h
	halt
wfr1h	halt
	call animFor
	pop bc
	djnz wFrames
	ret

putScene
	call cls
	ld hl,toonScr
	ld de,0x6000
	call DEHRUST
	call dropScr
	ld hl,levBuf
	ld b,176
pscn1	ld (hl),0
	inc hl
	djnz pscn1
	ret
	
cartAni	ld a,(de)
	and a
	ret z
	inc de
	ld c,a
	ld hl,carTab
cani1	ld a,(hl)
	and a
	jr z,cartAni
	inc hl
	cp c
	jr z,cani2
	inc hl
	inc hl
	jr cani1
cani2	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	call callHL
	jr cartAni

carTab	dbw 1,cani01	; 1,x,y		set nin1 pos
	dbw 2,cani02	; 2,x,y		set nin2 pos
	dbw 3,cani03	; 3,d		set nin1 dir
	dbw 4,cani04	; 4,d		set nin2 dir
	dbw 5,cani05	; 5,n		set nin1 spr
	dbw 6,cani06	; 6,n		set nin2 spr
	dbw 11,cani0B	; 11		restbgr1
	dbw 12,cani0C	; 12		restbgr2
	dbw 13,cani0D	; 13		savebgr1 + drawnin1
	dbw 14,cani0E	; 14		savebgr2 + drawnin2
	dbw 16,cani10	; 16,x,y,d,n	sprite n set on x,y and move to dir d
	dbw 17,cani11	; 17		stop box animation
	dbw 32,cani20	; 32,n		play n frames (with animation)
	dbw 33,cani21	; 32,n		pause n frames (no animation)
	dbw 40,cani28	; 40,n		setSFX n
	dbw 50,cani32	; 50		flash
	db 0
	
ani30	db 1,0,18,2,3,18
	db 3,2,4,2
	db 13,14
	db 40,9,32,8
	db 33,50
	db 40,9,32,7
	db 33,50
	db 3,0,4,8
	db 32,2
	db 4,4
	db 32,1
	db 40,7
	db 33,50
	db 3,1,4,1
	db 32,2
	db 3,3
	db 32,2
	db 40,7
	db 3,0
	db 32,2
	db 4,7
	db 32,3
	db 4,2
	db 32,1
	db 4,5
	db 32,2
	db 4,3
	db 32,1
	db 40,7
	db 33,50
	db 3,2,4,2
	db 40,9,32,5
	db 40,4
	db 12,2,255,0
	db 4,0
	db 32,6
	db 33,25
	db 3,1
	db 32,2
	db 40,4
	db 33,25
	db 11,1,255,0
	db 3,0
	db 32,25
	db 40,5
	db 50
	db 33,50
	db 40,5
	db 50
	db 33,50
	db 40,5
	db 50
	db 16,29,16,4,5
	db 1,30,18,2,28,18
	db 3,4,4,4
	db 13,14
	db 40,9,32,14
	db 40,1
	db 33,50
	db 40,9,32,14
	db 17
	db 11,12
	db 1,255,16,2,255,16
	db 3,0,4,0
	db 32,10
	
	
	db 0
	
ani20	db 1,19,0,2,255,0
	db 3,3,4,0
	db 13
	db 32,10
	db 40,7
	db 33,50
	db 3,2
	db 40,9,32,7
	db 33,25
	db 11,1,255,10
	db 40,4
	db 33,50
	db 40,5
	db 50
	db 1,26,10
	db 3,4
	db 13
	db 40,9,32,13
	db 3,6
	db 32,5
	db 3,3
	db 32,3
	db 40,7
	db 33,50
	dup 3
	 db 3,1
	 db 32,3
	 db 33,3
	 db 3,3
	 db 32,3
	 db 40,7
	 db 33,6
	edup
	db 33,50
	db 3,4
	db 40,9,32,10
	db 11,1,255,10
	db 32,50
	db 0
	
ani10	db 1,0,18,2,255,18
	db 3,2,4,0
	db 13
	db 40,9,32,8
	db 33,50
	db 40,9,32,9
	db 33,50
	db 40,9,32,9
	db 33,50
	db 3,1
	db 32,2
	db 40,4,33,25
	db 11,1,255,18
	db 3,0
	db 32,50
	db 40,5
	db 50
	db 1,26,16
	db 3,8
	db 32,5
	db 3,4
	db 32,5
	db 3,6
	db 32,7
	db 40,7
	db 33,50
	db 3,4
	db 40,9,32,10
	db 11,1,255,18
	db 3,0
	db 32,50
	db 0

cani01	ld hl,nin1x
	jr cani2a
cani02	ld hl,nin2x
cani2a	ld a,(de)
	ld (hl),a
	inc de
	inc hl
	ld a,(de)
	ld (hl),a
	inc de
	ret

cani03	ld a,(de)
	ld (nin1dir),a
	inc de
	ret
	
cani04	ld a,(de)
	ld (nin2dir),a
	inc de
	ret
	
cani05	ld a,(de)
	ld (nin1spr),a
	inc de
	ret
	
cani06	ld a,(de)
	ld (nin2spr),a
	inc de
	ret
	
cani0B	push de
	call RestBgr1
	ld bc,(nin1x)
	call updBC
	pop de
	ret
	
cani0C	push de
	call RestBgr2
	ld bc,(nin2x)
	call updBC
	pop de
	ret
	
cani0D	push de
	call SaveBgr1
	call DrawNin1
	pop de
	ret
	
cani0E	push de
	call SaveBgr2
	call DrawNin2
	pop de
	ret
	
cani10	ex de,hl
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ld e,(hl)
	inc hl
	push hl
	ld a,1
	ld (toonACT),a
	ld (toonXY),bc
	push bc
	ld (toonSPR),de
	ld de,toonBGR
	call savBgr
	pop bc
	push bc
	call bc2scr
	ex de,hl
	ld a,(toonSPR)
	call DrawBox
	pop bc
	call updBC
	pop de
	ret
	
cani11	push de
	xor a
	ld (toonACT),a
	ld bc,(toonXY)
	ld de,toonBGR
	call rstBgr
	pop de
	ret

cani20	ld a,(de)
	inc de
	push de
cani20a	push af
	halt
	call animFor
	call aniToon
	pop af
	dec a
	jr nz,cani20a
	pop de
	ret
	
cani21	ld a,(de)
	inc de
cani21a	halt
	dec a
	jr nz,cani21a
	ret

cani28	ld a,(de)
	inc de
	jp setSFX
	
cani32	push de
	halt
	ld a,7
	out (254),a
	ld hl,0x5800
	ld de,0x5801
	ld bc,0x2ff
	ld (hl),0x37
	ldir
	halt
	halt
	xor a
	out (254),a
	call dropScr
	pop de
toonRET	ret
	
aniToon	ld a,(toonACT)
	and a
	ret z
	ld bc,(toonXY)
	push bc
	ld de,toonBGR
	call rstBgr
	pop bc
	call updBC
	ld bc,(toonXY)
	ld a,(toonDIR)
	ld hl,tDirTab
	call jumpTab
	ld (toonXY),bc
	ld de,toonBGR
	call savBgr
	ld bc,(toonXY)
	push bc
	call bc2scr
	ex de,hl
	ld a,(toonSPR)
	call DrawBox
	pop bc
	jp updBC

tDirTab	dw toonRET,toonU,toonR,toonD,toonL
	
toonU	dec b
	ret
toonD	inc b
	ret
toonR	inc c
	ret
toonL	dec c
	ret
	
toonACT	db 0
toonXY	db 0,0
toonSPR	db 0
toonDIR	db 0

toonBGR	ds 36

toonScr	incbin "bin/zamok.hst"