doEdit
	ld a,(curLev)
	call popLev
	call strOff
	call nmOff
	call usOff
	call drwLev
edit_1	halt
	ld hl,edInpT
	call InKeys
	jr edit_1

edInpT	dw 0x01f7,edK1
	dw 0x02f7,edK2
	dw 0x04f7,edK3
	dw 0x08f7,edK4
	dw 0x02fe,edKZ
	dw 0x04fe,edKX
	
	dw 0x01fb,edKQ
	dw 0x01fd,edKA
	dw 0x01df,edKP
	dw 0x02df,edKO

	dw 0x017f,edSPC
	dw 0x04fd,edKD
	dw 0x08fe,edKC
	
	dw 0x02bf,edKL
	dw 0x04bf,edKK
;	dw 0x047f,edKM
;	dw 0x087f,edKN

	dw 0x02fb,edKW	; W:write
	dw 0x08fb,edKR	; R:read

	dw 0x01bf,edENT
	db 0

edKN	ld a,(curLev)
	and a
	jp z,noKey
	dec a
edkn1	push af
	call pushLev
	pop af
	ld (curLev),a
	call popLev
	call strOff
	jr edkr2

edKM	ld a,(curLev)
	cp maxlev-1
	jp nc,noKey
	inc a
	jr edkn1

edKC	ld hl,levBuf
	ld b,176
edkr1	ld (hl),0
	inc hl
	djnz edkr1
edkr2	call drwLev
	jp noKey

edKL	ld a,(curLev)
	cp maxlev
	jp nc,noKey
	inc a
	push af
	call edtSwpU
	jr edkk1

edKK	ld a,(curLev)
	sub 1
	jp c,noKey
	push af
	call edtSwpD
edkk1	pop af
	ld (curLev),a
	call edtLev
	jp noKey
	
edKZ	ld a,(turn)
	dec a
	jp z,noKey
edkz1	ld (turn),a
	call drwTurn
	jp noKey

edKX	ld a,(turn)
	inc a
	cp 24
	jr c,edkz1
	jp noKey

edKD	ld a,(edMode)
	and a
	jp nz,noKey
	xor a
	jr espc1
	
edSPC	ld a,(edMode)
	and a
	jp nz,noKey
	ld a,(curTile)
espc1	push af
	ld bc,(crsPos)
	call bc2map
	pop af
	push af
	ld (hl),a
	call crsOff
	call edtRBgr
	ld bc,(crsPos)
	call bc2scr
	ld a,h
	and 0x58
	ld d,a
	ld e,l
	pop af
	call DrawBox
	call edtSBgr
	call edtDNin
	call noKey
	jp crsOn

edK1	ld a,(curTile)
	dec a
	ret z
edz1	ld (curTile),a
	xor a
	ld (edMode),a
edz2	call edtTile
	jp noKey
	
edK2	ld a,(curTile)
	cp 15
	ret nc
	inc a
	jr edz1

edK3	ld a,1
	ld (edMode),a
	jr edz2
	
edK4	ld a,2
	ld (edMode),a
	jr edz2
	
edKQ	ld hl,edKUp
	jr edkm
edKA	ld hl,edKDn
	jr edkm
edKO	ld hl,edKLf
	jr edkm
edKP	ld hl,edKRg
edkm	ld a,(edMode)
	and 3
	add a,a
	add a,l
	ld l,a
	adc a,h
	sub l
	ld h,a
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	jp (hl)
	
edKUp	dw edCrsUp,edN1Up,edN2Up,edNone
edKDn	dw edCrsDn,edN1Dn,edN2Dn,edNone
edKLf	dw edCrsLf,edN1Lf,edN2Lf,edNone
edKRg	dw edCrsRg,edN1Rg,edN2Rg,edNone

edCrsUp	ld bc,(crsPos)
	dec b
	dec b
	jr edcrs
edCrsDn	ld bc,(crsPos)
	inc b
	inc b
	jr edcrs
edCrsLf	ld bc,(crsPos)
	dec c
	dec c
	jr edcrs
edCrsRg	ld bc,(crsPos)
	inc c
	inc c
edcrs	ld a,c
	cp 32
	ret nc
	ld a,b
	cp 22
	ret nc
	push bc
	call crsOff
	pop bc
	ld (crsPos),bc
	call crsOn
	jp noKey

edN1Up	ld bc,(nin1x)
	dec b
	dec b
	jr edmn1
edN1Dn	ld bc,(nin1x)
	inc b
	inc b
	jr edmn1
edN1Lf	ld bc,(nin1x)
	dec c
	dec c
	jr edmn1
edN1Rg	ld bc,(nin1x)
	inc c
	inc c
edmn1	ld a,c
	cp 32
	ret nc
	ld a,b
	cp 22
	ret nc
	push bc
	call crsOff
	call edtRBgr
	pop bc
	ld (nin1x),bc
	call edtSBgr
	call edtDNin
	call crsOn
	jp noKey
	
edN2Up	ld bc,(nin2x)
	dec b
	dec b
	jr edmn2
edN2Dn	ld bc,(nin2x)
	inc b
	inc b
	jr edmn2
edN2Lf	ld bc,(nin2x)
	dec c
	dec c
	jr edmn2
edN2Rg	ld bc,(nin2x)
	inc c
	inc c
edmn2	ld a,c
	cp 32
	ret nc
	ld a,b
	cp 22
	ret nc
	push bc
	call crsOff
	call edtRBgr
	pop bc
	ld (nin2x),bc
	call edtSBgr
	call edtDNin
	call crsOn
	jp noKey

edENT	call pushLev
	pop af		; reset edit key CALL
	pop af		; reset E key CALL (during play)
	call noKey
	call strOn
	jp mainGo

edKW	border 2
	call noKey
	call waitKey
	ld a,0xfb
	in a,(0xfe)
	and 2
	call z,wrLev
	border 0
	ret

edKR	border 4
	call noKey
	call waitKey
	ld a,0xfb
	in a,(0xfe)
	and 8
	call z,rdLev
	border 0
	ret

rdLev	border 6
	call findFle
	ld a,2
	jr z,wrlBA
	ld hl,lev000
	ld c,5
	call wrl00
	ld a,(curLev)
	call popLev
	call strOff
	call drwLev
	ret

wrLev	border 6
	call pushLev
	call findFle
	jr z,wrNew
	ld hl,lev000
	ld c,6
wrl00	call 0x3d13
wrlEX	ld a,4
wrlBA	di
	im 2
	ld a,0x80
	ld i,a
	ei
	out (0xfe),a
	ld b,25
edwr_1	halt
	djnz edwr_1
	ret
wrNew	ld hl,fileDSC
	ld c,0x13
	call 0x3d13
	ld hl,lev000
	ld de,levsize * maxlev
	ld c,0x0b
	jr wrl00

findFle	di
	im 1
	call 15649		; init trdos
	ld c,0x00
	call 0x3d13
	ld c,0x01		; drive A
	xor a
	call 0x3d13
	ld hl,fileDSC
	ld c,0x13
	call 0x3d13
	ld a,9
	ld (23814),a
	ld c,0x0a		; find file
	call 0x3d13
	ld a,c
	cp 0xff
	ret z
	ld c,0x08		; read DSC
	call 0x3d13
	ld a,(0x5cea)
	ld b,a
	ld de,(0x5ceb)
	or 2
	ret	

fileDSC	db "ninlevs C"
	dw lev000
	dw levsize * maxlev
	db 1,0,1

edtLev	ld de,0x50e0
	ld a,(curLev)
	inc a
	ld b,15
edtl1	inc b
	sub 10
	jr nc,edtl1
	add a,26
	push af
	ld a,b
	call prtChar
	pop af
	jp prtChar
	
pushLev	ld a,(curLev)
	call getLAdr
	ld de,levBuf
	ld b,88
plev1	ld a,(de)
	rla
	rla
	rla
	rla
	and 0xf0
	ld c,a
	inc de
	ld a,(de)
	and 0x0f
	or c
	inc de
	ld (hl),a
	inc hl
	djnz plev1
	ex de,hl
	ld bc,infsize
	ldir
edNone	ret

edtSwpU	ld de,levsize
	jr edswIN
edtSwpD	ld de,-levsize
edswIN	ld a,(curLev)
	call getLAdr
	ex de,hl
	add hl,de
	ld b,levsize
edsw1	ld a,(de)
	ld c,(hl)
	ld (hl),a
	ld a,c
	ld (de),a
	inc hl
	inc de
	djnz edsw1
	ret

edtSBgr	ld bc,(nin1x)
	ld de,nin1bgr
	call edtsbg
	ld bc,(nin2x)
	ld de,nin2bgr
edtsbg	call bc2scr
	ld a,h
	and 0x58
	ld h,a
	jp sbgrHL
	
edtRBgr	ld bc,(nin1x)
	ld de,nin1bgr
	call ednin1
	ld bc,(nin2x)
	ld de,nin2bgr
	jr ednin1

edtDNin	ld bc,(nin1x)
	call edtNin
	ld bc,(nin2x)
edtNin	ld de,sprGfx
ednin1	call bc2scr
	ld a,h
	and 0x58
	ld h,a
	jp rbgrHL
	
edtTile	ld de,0x50c3
	ld a,(edMode)
	and a
	jr nz,edmod1
	ld a,(curTile)
	jp dboxIN

edmod1	xor a
	call dboxNZ
	ld a,(edMode)
	dec a
	ld a,16
	jr z,edm1a
	inc a
edm1a	ld de,0x50e4
	jp prtChar

drwLev	ld de,0x4000
	call ffldDE
	ld de,0x4000
	call dfldDE
	call drwTurn
	call edtSBgr
	call edtDNin
	call edtTile
	call edtLev
crsOn	ld bc,(crsPos)
	call bc2scr
	ld a,h
	and 0x58
	ld h,a
	ld de,crsBgr
	push hl
	call sbgrHL
	pop hl
	ld de,crsSpr
	ld b,16
crson1	ld a,(de)
	xor (hl)
	ld (hl),a
	inc de
	inc l
	ld a,(de)
	xor (hl)
	ld (hl),a
	inc de
	dec l
	inc h
	ld a,h
	and 7
	jr nz,crson2
	ld a,l
	add a,32
	ld l,a
	jr c,crson2
	ld a,h
	sub 8
	ld h,a
crson2	djnz crson1
	ret
	
crsOff	ld bc,(crsPos)
	call bc2scr
	ld a,h
	and 0x58
	ld h,a
	ld de,crsBgr
	jp rbgrHL
	
edMode	db 0
curTile	db 1
crsPos	db 0,0
crsSpr	db 0xf0,0x0f,0x80,0x01,0x80,0x01,0x80,0x01
	db 0,0,0,0,0,0,0,0
	db 0,0,0,0,0,0,0,0
	db 0x80,0x01,0x80,0x01,0x80,0x01,0xf0,0x0f
crsBgr	ds 36
