doMenu	ld a,1
	call setMuz
	call muzOn
	xor a
	out (254),a
	ld hl,menuScr
	ld de,0x6000
	call DEHRUST
	call dropScr
;	ld de,0x50e2
;	ld hl,cprText
;	call prnText
	ld b,210
menu1	halt
	xor a
	in a,(254)
	cpl
	and 31
	jr nz,menu2
	djnz menu1
menu2	ld hl,0x5800
	ld d,0x5b
	halt
menu3	ld a,(hl)
	and 0x38
	cp 8
	jr nz,menu4
	xor (hl)
	ld (hl),a
menu4	inc hl
	ld a,h
	cp d
	jr c,menu3
	
	ld hl,0x4825
	ld c,20
	call lineFFF
	call lineFFF
	ld b,84
menu5	call lineCN
	djnz menu5
	call lineFFF
	call lineFFF
	ld hl,0x5925
	call lineA0
	ld b,7
menu6	call lineA1
	djnz menu6
	call lineA2
	call lineA2
	call lineA0
	
	ld hl,0x4825
	ld de,crnSpr
	call rbgrHL
	ld de,crnSpr + 36
	ld hl,0x4839
	call rbgrHL
	ld de,crnSpr + 72
	ld hl,0x5045
	call rbgrHL
	ld de,crnSpr + 108
	ld hl,0x5059
	call rbgrHL

	ld de,0x4847
	ld hl,m1txt
	call otxtP
	ld de,0x4887
	ld hl,m2txt
	call otxtP
	ld de,0x48c7
	ld hl,m3txt
	call otxtP
	ld de,0x502A
	ld hl,m4txt
	call otxtP
	
	xor a
	ld (scrlPix),a
	ld hl,scrlTxt
	ld (scrlAdr),hl
	
	ld a,0xaf
	ld (srlFlag),a
	
menuSW	ld de,0x4856
	ld a,(mvCloud)
	call mpOnOff
	ld de,0x4896
	ld a,(muzFlag)
	call mpOnOff
	ld de,0x48d6
	ld a,(sfxFlag)
	call mpOnOff
	
menuW	halt
;	call doScrl
	xor a
	in a,(254)
	cpl
	and 31
	jr nz,menuW
	
menuH	halt
;	call doScrl
	ld hl,menKeys
	call InKeys
	jr z,menuH
	jr menuSW

mpOnOff	ld hl,onTxt
	cp 0xa7
	jp z,otxtP
	ld hl,offTxt
	jp otxtP

m1txt	db "1.PARALAX......",0
m2txt	db "2.MUSIC........",0
m3txt	db "3.SOUND FX.....",0
m4txt	db "0.START GAME",0
	
onTxt	db ".ON",0
offTxt	db "OFF",0
	
cprText	db "(c) 2013, SAM style & mayHem",0
	
lineA0	ld a,0x70
	jr lineA
lineA1	ld a,0x71
	jr lineA
lineA2	ld a,0x72
lineA	ld de,0x7070
	call lineDAE
	ld de,32
	add hl,de
	ret
	
lineCN	ld de,0xC003
	xor a
	jr line
lineFFF	ld a,0xff
	ld d,a
	ld e,a
line	call lineDAE
	inc h
	ld a,h
	and 7
	ret nz
	ld a,l
	add a,32
	ld l,a
	ret c
	ld a,h
	sub 8
	ld h,a
	ret
	
lineDAE	push hl
	ld (hl),d
	inc l
	ld d,c
ldae1	ld (hl),a
	inc l
	dec c
	jr nz,ldae1
	ld c,d
	ld (hl),e
	pop hl
	ret

menKeys	dw 0x01f7,menK1
	dw 0x02f7,menK2
	dw 0x04f7,menK3
	dw 0x01ef,menK0
	db 0
	
menK0	call noKey
	ld a,0x37
	ld (srlFlag),a
	xor a
	ld (curLev),a
	call muzOff
	pop hl		; exit from menu
	ret

menK1	call prlxSw
	or 2
	ret
	
menK2	call muzSw
	or 2
	ret
	
menK3	call sfxSw
	or 2
	ret
	
crnSpr	incbin "bin/corners.bin"

; -- in-game menu

gamenu	
	call brgOff
	ld hl,0x40a8
	ld c,14
	call lineFFF
	call lineFFF
	ld b,92
gmen1	call lineCN
	djnz gmen1
	call lineFFF
	call lineFFF
	ld hl,0x58a8
	call lineA0
	ld b,10
gmen2	call lineA1
	djnz gmen2
	call lineA0
	
	ld hl,0x40a8
	ld de,crnSpr
	call rbgrHL
	ld hl,0x40b6
	ld de,crnSpr + 36
	call rbgrHL
	ld hl,0x48e8
	ld de,crnSpr + 72
	call rbgrHL
	ld hl,0x48f6
	ld de,crnSpr + 108
	call rbgrHL
	
	ld de,0x40c7
	ld hl,gmenTxt
	call menTxt
	
	xor a
	ld (gmePnkt),a
	call gmePOn
	
gmen3	ld de,0x4853
	ld a,(muzFlag)
	call mpOnOff
	ld de,0x4893
	ld a,(sfxFlag)
	call mpOnOff
	
	call noKey
gmen4	halt
	ld hl,gmeKeys
	call InKeys
	jr z,gmen4
	jr gmen3

gmeKeys	dw 0x01fb,gmeKQ
	dw 0x01fd,gmeKA
	dw 0x10bf,gmeKH
	dw 0x017f,gmeKSp
	dw 0x01bf,gmeKSp
	db 0
	
gmeKQ	call gmePOff
	ld a,(gmePnkt)
	sub 1
	jr nc,gkq1
	ld a,4
gkq1	ld (gmePnkt),a
	call gmePOn
	call noKey
	xor a
	ret
	
gmeKA	call gmePOff
	ld a,(gmePnkt)
	inc a
	cp 5
	jr c,gkq1
	xor a
	jr gkq1

gmeKSp	;call noKey
	ld a,(gmePnkt)
	ld hl,gmePExe
	add a,a
	add a,l
	ld l,a
	adc a,h
	sub l
	ld h,a
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	jp (hl)
	
gmePExe	dw gmeKH	; continue
	dw gmeK2	; reset
	dw gmeK3	; muz sw
	dw gmeK4	; sfx sw
	dw gmeK0	; quit

/*
gmeKeys	dw 0x01f7,gmeK1
	dw 0x02f7,gmeK2
	dw 0x04f7,gmeK3
	dw 0x08f7,gmeK4
	dw 0x01ef,gmeK0
	db 0
*/
gmeK3	call muzSw
	or 2
	ret
	
gmeK4	call sfxSw
	or 2
	ret
	
gmeKH	pop af		; gmenKH
	call noKey
menOff	ld hl,0x78a0
	ld de,0x58a0
	exx
	ld de,0x40a8
	ld hl,0x60a8
	ld a,12
gmk10	exa
gmk11	ld a,l
	ld bc,17
	ldir
	ld l,a
	ld e,a
	inc h
	inc d
	ld a,d
	and 7
	jr nz,gmk11
	ld a,e
	add a,32
	ld e,a
	ld a,d
	jr c,gmk12
	sub 8
	ld d,a
gmk12	or 0x20
	ld h,a
	ld l,e
	exx
	ld bc,32
	ldir
	exx
	exa
	dec a
	jr nz,gmk10
	jp atrRst
	
gmeK2	pop af	; gmen K2
	pop af	; call gamenu
	pop af	; game KH
	call noKey
	jp mainGo
	
gmeK0	pop af	; gmen K0
	pop af	; call gamenu
	pop af	; game KH
	call usOff
	call noKey
	call cls
	jp mainTS
	
gmenTxt	dw 0x40ca
	db "BACK TO GAME",0
	dw 0x480a
	db "RESET  LEVEL",0
	dw 0x484a
	db "MUSIC....",0
	dw 0x488a
	db "SFX......",0
	dw 0x48ca
	db "EXIT TO MENU",0
	dw 0

menTxt	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ld a,d
	or e
	ret z
	call otxtP
	inc hl
	jr menTxt
	
gmePnkt	db 0

gmePOff	ld c,0x31	; pap 6 ink 1
	jr gmePC
gmePOn	ld c,0x17	; pap 2 ink 7
gmePC	ld a,(gmePnkt)
	ld l,a
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl	; x64
	ld de,0x58c9
	add hl,de	; hl:atr adr
	ld b,14
	ld de,32-14
	call gpcrs2
	add hl,de
	ld b,14
gpcrs2	ld a,(hl)
	and 0xc0
	or c
	ld (hl),a
	inc l
	djnz gpcrs2
	ret
	
brgOff	ld hl,0x5800
sdrk1	ld a,(hl)
	and 0x3f
	ld (hl),a
	inc hl
	ld a,h
	cp 0x5b
	jr c,sdrk1
	ret
	
atrRst	ld hl,0x7800
	ld de,0x5800
	ld bc,0x300
	halt
	ldir
	ret

doScrl	ld a,(scrlPix)
	and 7
	jr nz,dscr02
	ld hl,(scrlAdr)
	ld a,(hl)
	cp 31
	jr nc,dscr01
	ld hl,scrlTxt
	ld a,(hl)
dscr01	inc hl
	ld (scrlAdr),hl
	ld de,0x6000
	sub 32
	call prtChar
	ld a,(scrlPix)
dscr02	inc a
	ld (scrlPix),a
	ld hl,0x50ff
	ld de,0x6000
	ld b,8
dscr03	ld a,(de)
	rla
	ld (de),a
	ld c,32
dscr04	rl (hl)
	dec l
	dec c
	jr nz,dscr04
	ld l,0xff
	inc d
	inc h
	djnz dscr03
	ret
	
scrlPix	db 0
scrlAdr	dw scrlTxt

scrlTxt	db "SAM style & SAND/mayHem & NQ/skrju glad to prezzzent you our new game - "
	db "= Ninja twins. Going to zedeaks =. "
	db "A prototype of this game is NINJA TWINS, a KronBits game, with 25 original levels. "
	db "Press 1,2,3 keys for change a game options or 0 for start game. "
	db "If you have level code, type it, or press ENTER to start level 1. "
	db "The goal of each level is to take threasure chest and try not die. "
	db "QAOP - move ninjas, M - switch music, F - switch sfx, C - switch background animation, "
	db "R - reset level, H - show menu. "
	ds 32," "
	db "Enjoy!"
	ds 32," "
	db 0

menuScr	incbin "bin/menu.hst"