muzSw	ld a,(muzFlag)
	xor 0x90
	ld (muzFlag),a
	cp 0x37
	jr z,moff1
	ret
	
muzOn	ld a,0xa7
	ld (mzFlag),a
	ret
muzOff	ld a,0x37
	ld (mzFlag),a
moff1	ld a,(curBank)
	push af
	ld a,muzBank
	call bank
	call player+8
	call oregz
	pop af
	ei
	jp bank

sfxSw	ld a,(sfxFlag)
	cp 0xa7
	jr z,sfxOff
sfxOn	ld a,0xa7
	ld (sfxFlag),a
	ret
sfxOff	ld a,0x37
	ld (sfxFlag),a
	ret
	
playMuz	ld a,(curBank)
	push af
	ld a,muzBank
	call bank
muzFlag	and a		; global
	jr c,sfxFlag
mzFlag	scf		; temporary on/off
	call nc,player+5
sfxFlag	and a
	ld hl,p1.ayregs
	call nc,smpPlay
	call oregz

	pop af
	jr bank

oregz	xor a		; out AY regs from HL (part of PT3 player)
        ld de,#ffbf
        ld bc,#fffd
lout    out (c),a
        ld b,e
        outi
        ld b,d
        inc a
        cp 13
        jr nz,lout
        out (c),a
        ld a,(hl)
        and a
        ret m
        ld b,e
        out (c),a
	ret

setMuz	halt
	add a,a
	ld hl,muzTab
	add a,l
	ld l,a
	adc a,h
	sub l
	ld h,a
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	ld a,(curBank)
	push af
	ld a,muzBank
	call bank
	call player+3
	ei
	pop af
	call bank
	jp muzOn

muzTab	dw gamMuz,menMuz,lcomMuz,failMuz