; set, play PT3 sample in channel A
; data must builded on ayregs

smpPlay	
	ld a,(smpCnt)
	sub 1
	ret c
	ld (smpCnt),a
	ret z
	ld de,regs
	ld bc,14
	ldir
	ld hl,(smpAdr)
	ld c,(hl)		; +0,1:tone shift
	inc hl
	ld b,(hl)
	inc hl
	ex de,hl
	ld hl,(smpTone)
	add hl,bc
	ld (regs + 0),hl	; 0,1 : tone A
	ex de,hl
	ld a,(hl)		; +2: b0..4 = noize, b765=TNE (1:off)
	and 0x1f
	ld (regs + 6),a		; 6 : noize
	ld a,(regs + 7)
	and %11110110
	ld c,a
	ld a,(hl)
	rla		; T
	jr nc,spl_T
	set 0,c
spl_T	rla		; N
	jr nc,spl_N
	set 3,c
spl_N	ld a,c
	ld (regs+7),a
	inc hl
	ld a,(hl)		; +3: b0..3 = volume, b5:ts
	and 0x0f
	ld (regs + 8),a		; 8 : volume A
	ld a,(hl)
	and 0x20
	jr z,sply01
	ld (smpTone),de
sply01	
	inc hl
	ld (smpAdr),hl
	ld hl,regs
	ret

regs	ds 14

; A = sfx number

setSFX	push de
	ld d,a
	ld a,(sfxFlag)
	cp 0xa7
	jr nz,ssfxEx
	ld a,d
	push hl
	ld hl,smpTab
	add a,a
	add a,l
	ld l,a
	adc a,h
	sub l
	ld h,a
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ld (smpTone),de
	ld a,(hl)
	inc hl
	ld (smpCnt),a
	ld (smpAdr),hl
	pop hl
ssfxEx	pop de
	ret

smpCnt	db 0
smpTone	dw 0
smpNoiz	db 0
smpAdr	dw 0

smpTab	dw 0,smp01,0,smp03,smp04,smp05,smp06,smp07,smp08,smp09,0,0,smp12

smp01	dw 0x1df	; C4
	incbin "muz/smp01C4.smp"
smp03	dw 0x3be	; C3
	incbin "muz/smp03C3.smp"
smp04	dw 0x27c	; G3
	incbin "muz/smp04G3.smp"
smp05	dw 0x1df	; C4
	incbin "muz/smp05C4.smp"
smp06	dw 0x12c	; G#4
	incbin "muz/smp06G#4.smp"
smp07	dw 0x1df
	incbin "muz/smp07C4.smp"
smp08	dw 0x1df
	incbin "muz/smp08C4.smp"
smp09	dw 0x1df
	incbin "muz/smp09C4.smp"
smp12	dw 0x1df
	incbin "muz/smp12C4.smp"
